# CbcFullNodeInfo Class Reference

Information required to recreate the subproblem at this node. More...

`#include <CbcFullNodeInfo.hpp>`

Inheritance diagram for CbcFullNodeInfo:
[legend]
Collaboration diagram for CbcFullNodeInfo:
[legend]

List of all members.

## Public Member Functions
virtual void | applyToModel (CbcModel *model, CoinWarmStartBasis *&basis, CbcCountRowCut **addCuts, int &currentNumberCuts) const
| Modify model according to information at node.
virtual int | applyBounds (int iColumn, double &lower, double &upper, int force)
| Just apply bounds to one variable - force means overwrite by lower,upper (1=>infeasible).
virtual CbcNodeInfo * | buildRowBasis (CoinWarmStartBasis &basis) const
| Builds up row basis backwards (until original model).
| CbcFullNodeInfo ()
| CbcFullNodeInfo (CbcModel *model, int numberRowsAtContinuous)
| Constructor from continuous or satisfied.
| CbcFullNodeInfo (const CbcFullNodeInfo &)
| ~CbcFullNodeInfo ()
virtual CbcNodeInfo * | clone () const
| Clone.
const double * | lower () const
| Lower bounds.
void | setColLower (int sequence, double value)
| Set a bound.
double * | mutableLower () const
| Mutable lower bounds.
const double * | upper () const
| Upper bounds.
void | setColUpper (int sequence, double value)
| Set a bound.
double * | mutableUpper () const
| Mutable upper bounds.
## Protected Attributes
CoinWarmStartBasis * | basis_
| Full basis.
int | numberIntegers_
double * | lower_
double * | upper_
## Private Member Functions
CbcFullNodeInfo & | operator= (const CbcFullNodeInfo &rhs)
| Illegal Assignment operator.

## Detailed Description

Information required to recreate the subproblem at this node.

When a subproblem is initially created, it is represented by a CbcNode object and an attached CbcNodeInfo object.

The CbcNode contains information needed while the subproblem remains live. The CbcNode is deleted when the last branch arm has been evaluated.

The CbcNodeInfo contains information required to maintain the branch-and-cut search tree structure (links and reference counts) and to recreate the subproblem for this node (basis, variable bounds, cutting planes). A CbcNodeInfo object remains in existence until all nodes have been pruned from the subtree rooted at this node.

The principle used to maintain the reference count is that the reference count is always the sum of all potential and actual children of the node. Specifically,

- Once it's determined how the node will branch, the reference count is set to the number of potential children (i.e., the number of arms of the branch).
- As each child is created by CbcNode::branch() (converting a potential child to the active subproblem), the reference count is decremented.
- If the child survives and will become a node in the search tree (converting the active subproblem into an actual child), increment the reference count.

Notice that the active subproblem lives in a sort of limbo, neither a potential or an actual node in the branch-and-cut tree.

CbcNodeInfo objects come in two flavours. A CbcFullNodeInfo object contains a full record of the information required to recreate a subproblem. A CbcPartialNodeInfo object expresses this information in terms of differences from the parent. Holds complete information for recreating a subproblem.

A CbcFullNodeInfo object contains all necessary information (bounds, basis, and cuts) required to recreate a subproblem.

Todo:
  While there's no explicit statement, the code often makes the implicit assumption that an CbcFullNodeInfo structure will appear only at the root node of the search tree. Things will break if this assumption is violated.

Definition at line 81 of file CbcFullNodeInfo.hpp.

## Constructor & Destructor Documentation

CbcFullNodeInfo::CbcFullNodeInfo | ( |  | ) |

CbcFullNodeInfo::CbcFullNodeInfo | ( | CbcModel * | model,
|  | int | numberRowsAtContinuous |
| ) |  |  |

Constructor from continuous or satisfied.

CbcFullNodeInfo::CbcFullNodeInfo | ( | const CbcFullNodeInfo & |  | ) |

CbcFullNodeInfo::~CbcFullNodeInfo | ( |  | ) |

## Member Function Documentation

virtual void CbcFullNodeInfo::applyToModel | ( | CbcModel * | model,
|  | CoinWarmStartBasis *& | basis,
|  | CbcCountRowCut ** | addCuts,
|  | int & | currentNumberCuts |
| ) |  |  | const`[virtual]`

Modify model according to information at node.

The routine modifies the model according to bound information at node, creates a new basis according to information at node, but with the size passed in through basis, and adds any cuts to the addCuts array.

Note:
  The basis passed in via basis is solely a vehicle for passing in the desired basis size. It will be deleted and a new basis returned.

Implements CbcNodeInfo.

virtual int CbcFullNodeInfo::applyBounds | ( | int | iColumn,
|  | double & | lower,
|  | double & | upper,
|  | int | force |
| ) |  |  | `[virtual]`

Just apply bounds to one variable - force means overwrite by lower,upper (1=>infeasible).

Implements CbcNodeInfo.

virtual CbcNodeInfo* CbcFullNodeInfo::buildRowBasis | ( | CoinWarmStartBasis & | basis | ) | const`[virtual]`

Builds up row basis backwards (until original model).

Returns NULL or previous one to apply . Depends on Free being 0 and impossible for cuts

Implements CbcNodeInfo.

virtual CbcNodeInfo* CbcFullNodeInfo::clone | ( |  | ) | const`[virtual]`

Clone.

Implements CbcNodeInfo.

const double* CbcFullNodeInfo::lower | ( |  | ) | const`[inline]`

Lower bounds.

Definition at line 123 of file CbcFullNodeInfo.hpp.

void CbcFullNodeInfo::setColLower | ( | int | sequence,
|  | double | value |
| ) |  |  | `[inline]`

Set a bound.

Definition at line 127 of file CbcFullNodeInfo.hpp.

double* CbcFullNodeInfo::mutableLower | ( |  | ) | const`[inline]`

Mutable lower bounds.

Definition at line 130 of file CbcFullNodeInfo.hpp.

const double* CbcFullNodeInfo::upper | ( |  | ) | const`[inline]`

Upper bounds.

Definition at line 134 of file CbcFullNodeInfo.hpp.

void CbcFullNodeInfo::setColUpper | ( | int | sequence,
|  | double | value |
| ) |  |  | `[inline]`

Set a bound.

Definition at line 138 of file CbcFullNodeInfo.hpp.

double* CbcFullNodeInfo::mutableUpper | ( |  | ) | const`[inline]`

Mutable upper bounds.

Definition at line 141 of file CbcFullNodeInfo.hpp.

CbcFullNodeInfo& CbcFullNodeInfo::operator= | ( | const CbcFullNodeInfo & | rhs | ) | `[private]`

Illegal Assignment operator.

Reimplemented from CbcNodeInfo.

## Member Data Documentation

CoinWarmStartBasis* CbcFullNodeInfo::basis_`[protected]`

Full basis.

This MUST BE A POINTER to avoid cutting extra information in derived warm start classes.

Definition at line 151 of file CbcFullNodeInfo.hpp.

int CbcFullNodeInfo::numberIntegers_`[protected]`

Definition at line 152 of file CbcFullNodeInfo.hpp.

double* CbcFullNodeInfo::lower_`[protected]`

Definition at line 154 of file CbcFullNodeInfo.hpp.

double* CbcFullNodeInfo::upper_`[protected]`

Definition at line 155 of file CbcFullNodeInfo.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.8.0/Cbc/src/CbcFullNodeInfo.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines